%MACRO PLSTWOAF;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '1ST';
IF IFORM = 'MSC';
IF IMCVS = 'SAS';
IF IGAPS = '4';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 8 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 8 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 8 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '1ST';
IF IFORM = 'MSC';
IF IMCVS = 'SAS';
IF IGAPS = '8';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 10 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 10 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 10 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '1ST';
IF IFORM = 'MSC';
IF IMCVS = 'SAS';
IF IGAPS = '16';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 13 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 13 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 13 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '1ST';
IF IFORM = 'MSC';
IF IMCVS = 'SAS';
IF IGAPS = '32';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 12 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 12 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 12 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '1ST';
IF IFORM = 'MSC';
IF IMCVS = 'SAS';
IF IGAPS = '64';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 10 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 10 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 10 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '1ST';
IF IFORM = 'STR';
IF IMCVS = 'SAS';
IF IGAPS = '4';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 10 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 10 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 10 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '1ST';
IF IFORM = 'STR';
IF IMCVS = 'SAS';
IF IGAPS = '8';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 12 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 12 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 12 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '1ST';
IF IFORM = 'STR';
IF IMCVS = 'SAS';
IF IGAPS = '16';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 11 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 11 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 11 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '1ST';
IF IFORM = 'STR';
IF IMCVS = 'SAS';
IF IGAPS = '32';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 14 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 14 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 14 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '1ST';
IF IFORM = 'STR';
IF IMCVS = 'SAS';
IF IGAPS = '64';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 11 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 11 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 11 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '2ND';
IF IFORM = 'MSC';
IF IMCVS = 'SAS';
IF IGAPS = '4';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 4 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 4 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 4 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '2ND';
IF IFORM = 'MSC';
IF IMCVS = 'SAS';
IF IGAPS = '8';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 4 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 4 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 4 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '2ND';
IF IFORM = 'MSC';
IF IMCVS = 'SAS';
IF IGAPS = '16';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 7 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 7 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 7 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '2ND';
IF IFORM = 'MSC';
IF IMCVS = 'SAS';
IF IGAPS = '32';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 14 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 14 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 14 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '2ND';
IF IFORM = 'MSC';
IF IMCVS = 'SAS';
IF IGAPS = '64';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 15 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 15 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 15 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '2ND';
IF IFORM = 'STR';
IF IMCVS = 'SAS';
IF IGAPS = '4';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 6 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 6 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 6 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '2ND';
IF IFORM = 'STR';
IF IMCVS = 'SAS';
IF IGAPS = '8';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 7 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 7 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 7 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '2ND';
IF IFORM = 'STR';
IF IMCVS = 'SAS';
IF IGAPS = '16';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 12 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 12 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 12 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '2ND';
IF IFORM = 'STR';
IF IMCVS = 'SAS';
IF IGAPS = '32';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 14 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 14 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 14 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = '2ND';
IF IFORM = 'STR';
IF IMCVS = 'SAS';
IF IGAPS = '64';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 14 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 14 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 14 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = 'NON';
IF IFORM = 'MSC';
IF IMCVS = 'SAS';
IF IGAPS = '0';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 14 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 14 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 14 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

DATA TEMP; SET TOTAL;
IF IDERIVAT = 'NON';
IF IFORM = 'STR';
IF IMCVS = 'SAS';
IF IGAPS = '0';

%IF &MCOPTION = "PRO" %THEN %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 13 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE     P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = PRO */ 
    
%ELSE %IF &MCOPTION = "SAS" %THEN %DO;
      PROC PLS DATA = TEMP NFAC = 13 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END MCOPTION = SAS */ 
    
%ELSE %DO;
      PROC PLS DATA = TEMP NOCENTER NOSCALE NFAC = 13 NOPRINT;
            MODEL CHEMANALYTES&X = ABS1-ABS&MAXINDEX;
            OUTPUT OUT = PREDCHEMANALYTE P = P_CHEMANALYTE XSCORE = T;
            RUN;
%END; /* END ELSE OPTION */ 

DATA VALIDAT; INFILE "&VALIDATIONFILE";
INPUT ID $ OANALYTE1 - OANALYTE&MAXVARS;
RUN;
PROC SORT DATA = VALIDAT;
     BY ID;
RUN;
DATA PREDVAL; SET PREDCHEMANALYTE;
     IF CHEMANALYTES&X NE  . THEN DELETE;
PROC SORT; BY ID;

DATA ORIGPREDVAL; MERGE VALIDAT PREDVAL;
     BY ID;

DATA SAVPREDACTVAL; SET ORIGPREDVAL;
CALVAL = 'VAL';
ACTUAL = OANALYTE&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTVAL FORCE;
RUN;
PROC CORR DATA = ORIGPREDVAL OUT = VALCORROUT NOPRINT;
     VAR OANALYTE&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDVALIDATION; SET VALCORROUT;
IF _TYPE_ = 'CORR' THEN
     OANALYTE&X = OANALYTE&X*OANALYTE&X;
ELSE 
     DELETE;
DATA PREDVAL; SET ORIGPREDVAL;
DIF = OANALYTE&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMVAL SUM = SDIF SDSQ;
RUN;
DATA SUMSTATS; SET SUMVAL;
VPRESS = SDSQ;
VRMSD = SQRT (VPRESS/&NUMVALFILES);
VSEP = SQRT (VPRESS/(&NUMVALFILES - 1));
VBIAS = SDIF/&NUMVALFILES;
VSEPC = SQRT ((VPRESS - &NUMVALFILES * VBIAS * VBIAS) / (&NUMVALFILES - 1));
RUN;
DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDVALIDATION; MERGE SQUAREDVALIDATION SUMSTATS;
TITLE "CALIBRATION RESULTS";

PROC CORR DATA = PREDCHEMANALYTE OUT = CALCORROUT NOPRINT;
     VAR CHEMANALYTES&X; WITH P_CHEMANALYTE;
RUN;

DATA SQUAREDCAL; SET CALCORROUT;
IF _TYPE_ = 'CORR' THEN
     CHEMANALYTES&X = CHEMANALYTES&X*CHEMANALYTES&X;
ELSE
     DELETE;

DATA SQUAREDCAL; MERGE SQUAREDCAL SQUAREDVALIDATION;
DATA PREDCAL; SET PREDCHEMANALYTE;
IF CHEMANALYTES&X = . THEN DELETE;
RUN;
DATA SAVPREDACTCAL; SET PREDCAL;
CALVAL = 'CAL';
ACTUAL = CHEMANALYTES&X;
CHEM = &X;
KEEP CHEM CALVAL IFORM IDERIVAT IMCVS IGAPS ID ACTUAL P_CHEMANALYTE;
RUN;
PROC APPEND BASE = PREDICTACTUAL DATA = SAVPREDACTCAL FORCE;
RUN;
DATA PREDCAL; SET PREDCAL;
DIF = CHEMANALYTES&X - P_CHEMANALYTE;
DSQ = DIF * DIF;

PROC SUMMARY;
VAR DIF DSQ;
OUTPUT OUT = SUMCAL SUM = SDIF SDSQ;
RUN;

DATA SUMSTATS; SET SUMCAL;
PRESS = SDSQ;
RMSD = SQRT (PRESS/&NUMCALFILES);
SEP = SQRT (PRESS/(&NUMCALFILES - 1));
BIAS = SDIF/&NUMCALFILES;
SEPC = SQRT ((PRESS - &NUMCALFILES * BIAS * BIAS) / (&NUMCALFILES - 1));
RUN;

DATA SUMSTATS; SET SUMSTATS;
DROP _TYPE_;
DROP _FREQ_;
DATA SQUAREDCAL; MERGE SQUAREDCAL SUMSTATS;
PROC APPEND BASE = SUMCALVAL DATA = SQUAREDCAL FORCE;
RUN;

%MEND PLSTWOAF;


